############################################################
# 
# <p>Layoutץ饰Υƥץ졼Ȥƥץ졼Ⱦޤ</p>
# 
############################################################
package plugin::layout::LayoutUtil;
use Util;
use strict;

#===========================================================
# ƥץ졼Ȱؿ
#===========================================================
sub get_tmpl_list {
	my $wiki = shift;
	
	my @list;
	opendir(DIR,$wiki->config('tmpl_dir')."/layout") or die $!;
	while(my $entry = readdir(DIR)){
		my $path = $wiki->config('tmpl_dir')."/layout/$entry";
		if(-f $path && $entry =~ /^(.*)\.tmpl$/ ){
			push(@list,$1);
		}
	}
	closedir(DIR);
	
	@list = sort(@list);
	return @list;
}

#===========================================================
# ƥץ졼ȡեβ
# ƥץ졼Ȥ˵ΥեޥåȤǵҤ줿ɤ߹ߤޤ
#===========================================================
sub get_tmpl_info {
	my $wiki = shift;
	my $tmpl = shift;
	
	my $tmplinfo = undef;
	my $tmplsrc  = undef;
	
	# ƥץ졼̾å
	return undef if ($tmpl =~ /\.\./);
	# ƥץ졼¸ߥå
	$tmplinfo->{TEMPLATE} = $wiki->config('tmpl_dir')."/layout/".$tmpl.".tmpl";
	return undef if ( ! -f $tmplinfo->{TEMPLATE} );
	
	open(TEMPLATE, $tmplinfo->{TEMPLATE});
	while (read(TEMPLATE, $tmplsrc, 10240, length($tmplsrc))) {};
	close(TEMPLATE);
	
	my ($layout,$help) = 0;
	foreach (split("\n",$tmplsrc)) {
		if ( /^-- LAYOUTINFO_START/ ) {
			$layout = 1;
		} elsif ( /^-- LAYOUTINFO_END/ ) {
			last;
		} else {
			next if (! $layout);
			if ( /^-- \b(TITLE)\b[\s\t]*:[\s\t]*(.+)/ ) {
				## STRING: ȥ
				$tmplinfo->{$1} = $2;
			} elsif ( /^-- \b(PARAMETER)\b[\s\t]*:[\s\t]*([\$]?\w+)[\s\t]*,[\s\t]*(WIKI|\/(.*)\/)/ ) {
				## HASH  : Ѳǽʥѥ᡼ϵ§
				$tmplinfo->{$1}->{$2}->{type} = 'TEXT';
				$tmplinfo->{$1}->{$2}->{type} = $3 if (defined($3));
				$tmplinfo->{$1}->{$2}->{validation} = $4;
				push(@{$tmplinfo->{PARAMETERLIST}}, $2);
			} elsif ( /^-- \b(SOURCE)\b[\s\t]*:[\s\t]*(WIKI|TEXT)[\s\t]*/ ) {
				$tmplinfo->{$1} = $2 || 'WIKI';
			} elsif ( /^-- HELP_START(:(WIKI|HTML))?/ ) {
				$help = 1;
				if ( defined($2) ) {
					$tmplinfo->{HELP_STYLE} = $2;
				} else {
					$tmplinfo->{HELP_STYLE} = "WIKI";
				}
			} elsif ( /^-- HELP_END/ ) {
				$help = 0;
				next;
			} else {
				if ( $help ) {
					## STRING: ˡ
					$tmplinfo->{HELP} .= $_."\n";
				}
			}
		}
	}
	
	return $tmplinfo;
}

#==============================================================================
# <p>
# ѥ᡼Ϥ줿 ƥץ졼ȡ Wikiɤޤ
# </p>
# ѥ᡼ΰʲεWikiѴޤ
# <pre>
#   <!--FSWIKI_SOURCE-->Wiki<!--/FSWIKI_SOURCE-->
# </pre>
# ѥ᡼ΰʲεWikiڡѴޤ
# <pre>
#   <!--FSWIKI_INCLUDE PAGE='<Wikiڡ>'-->
# </pre>
#==============================================================================
sub process_template {
	my $wiki = shift;
	my $source = shift;
	
	my @lines = split(/\n/,$source);
	my $html = "";
	
	while ($source =~ /<!--\s*(FSWIKI_SOURCE|FSWIKI_INCLUDE|FSWIKI_HEAD_INFO)(\s+(PAGE=)?["']([\w\-\.]*)['"])?\s*-->/i) {
		$html .= $`;
		my $a = $';
		if (uc($1) eq 'FSWIKI_SOURCE') {
			if ( $a =~ /<!--\s*\/FSWIKI_SOURCE\s*-->/i ) {
				$html .= $wiki->process_wiki($`);
				$a = $';
			}
		} elsif (uc($1) eq 'FSWIKI_INCLUDE') {
			if ($wiki->page_exists($4) && $wiki->can_show($4)) {
#				$html .= $wiki->process_wiki("{{include $4}}");
				$html .= $wiki->process_wiki($wiki->get_page($4));
			}
		} elsif (uc($1) eq 'FSWIKI_HEAD_INFO') {
			if ( $a =~ /<!--\s*\/FSWIKI_HEAD_INFO\s*-->/i ) {
				$wiki->add_head_info($`);
				$a = $';
			}
		}
		$source = $a;
	}
	$html .= $source;
	return $html;
}

#==============================================================================
# <p>
# ѥ᡼Ϥ줿 ƥץ졼ȡ Υڡ¸ߥåޤ
# </p>
# ڡ¸ߥåѤʲ 'EXIST_PAGE_<ڡ̾>' ˳ڡ¸ߥåͤޤ
# <pre>
#   <!--TMPL_IF NAME='EXIST_PAGE_<ڡ̾>'-->
# </pre>
#==============================================================================
sub set_template_exist_page {
	my $wiki = shift;
	my $tmpl = shift;
	
	my $tmplpath = $tmpl->{options}->{filepath};
	my $tmplsrc = $tmpl->{template};
	
	open(TEMPLATE, $tmplpath);
	while (read(TEMPLATE, $tmplsrc, 10240, length($tmplsrc))) {}
	close(TEMPLATE);
	
	while ( $tmplsrc =~ /<!--\s*[Tt][Mm][Pp][Ll]_[Ii][Ff]\s+(NAME=)?["']?EXIST_PAGE_([\w\/\-\.]+)['"]?\s*-->/ ) {
		if(index($2,"/")==-1 && $wiki->can_show($2)){
			$tmpl->param("EXIST_PAGE_".$2=>1);
		}
		$tmplsrc = $';
	}
}

1;
